Date

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util
Class Date

    java.lang.Object
      java.util.Date

All Implemented Interfaces:
  Serializable, Cloneable, Comparable

    public class Date

extends Object
implements Serializable, Cloneable, Comparable

The class `Date` represents a specific instant in time, with millisecond precision.

Prior to JDK 1.1, the class `Date` had two additional functions. It allowed the interpretation of dates as year, month, day, hour, minute, and second values. It also allowed the formatting and parsing of date strings. Unfortunately, the API for these functions was not amenable to internationalization. As of JDK 1.1, the `Calendar` class should be used to convert between dates and time fields and the `DateFormat` class should be used to format and parse date strings. The corresponding methods in `Date` are deprecated.

Although the `Date` class is intended to reflect coordinated universal time (UTC), it may not do so exactly, depending on the host environment of the Java Virtual Machine. Nearly all modern operating systems assume that 1 day = 24 × 60 × 60 = 86400 seconds in all cases. In UTC, however, about once every year or two there is an extra second, called a "leap second." The leap second is always added as the last second of the day, and always on December 31 or June 30. For example, the last minute of the year 1995 was 61 seconds long, thanks to an added leap second. Most computer clocks are not accurate enough to be able to reflect the leap-second distinction.

Some computer standards are defined in terms of Greenwich mean time (GMT), which is equivalent to universal time (UT). GMT is the "civil" name for the standard; UT is the "scientific" name for the same standard. The distinction between UTC and UT is that UTC is based on an atomic clock and UT is based on astronomical observations, which for all practical purposes is an invisibly fine hair to split. Because the earth's rotation is not uniform (it slows down and speeds up in complicated ways), UT does not always flow uniformly. Leap seconds are introduced as needed into UTC so as to keep UTC within 0.9 seconds of UT1, which is a version of UT with certain corrections applied. There are other time and date systems as well; for example, the time scale used by the satellite-based global positioning system (GPS) is synchronized to UTC but is not adjusted for leap seconds. An interesting source of further information is the U.S. Naval Observatory, particularly the Directorate of Time at:

>          http://tycho.usno.navy.mil

and their definitions of "Systems of Time" at:

>          http://tycho.usno.navy.mil/systime.html

In all methods of class `Date` that accept or return year, month, date, hours, minutes, and seconds values, the following representations are used:

- A year y is represented by the integer y `- 1900`.
- A month is represented by an integer from 0 to 11; 0 is January, 1 is February, and so forth; thus 11 is December.
- A date (day of month) is represented by an integer from 1 to 31 in the usual manner.
- An hour is represented by an integer from 0 to 23. Thus, the hour from midnight to 1 a.m. is hour 0, and the hour from noon to 1 p.m. is hour 12.
- A minute is represented by an integer from 0 to 59 in the usual manner.
- A second is represented by an integer from 0 to 61; the values 60 and 61 occur only for leap seconds and even then only in Java implementations that actually track leap seconds correctly. Because of the manner in which leap seconds are currently introduced, it is extremely unlikely that two leap seconds will occur in the same minute, but this specification follows the date and time conventions for ISO C.

In all cases, arguments given to methods for these purposes need not fall within the indicated ranges; for example, a date may be specified as January 32 and is interpreted as meaning February 1.

Since:
  JDK1.0
Version:
  1.70 11/09/00
Author:
  James Gosling, Arthur van Hoff, Alan Liu
See Also:
  `DateFormat`, `Calendar`, `TimeZone`, Serialized Form

Constructor Summary
`Date()` Allocates a `Date` object and initializes it so that it represents the time at which it was allocated, measured to the nearest millisecond.
`Date(long date)` Allocates a `Date` object and initializes it to represent the specified number of milliseconds since the standard base time known as "the epoch", namely January 1, 1970, 00:00:00 GMT.

Method Summary
`boolean` | `after(Date when)` Tests if this date is after the specified date.
`boolean` | `before(Date when)` Tests if this date is before the specified date.
`Object` | `clone()` Return a copy of this object.
`int` | `compareTo(Date anotherDate)` Compares two Dates for ordering.
`int` | `compareTo(Object o)` Compares this Date to another Object.
`boolean` | `equals(Object obj)` Compares two dates for equality.
`long` | `getTime()` Returns the number of milliseconds since January 1, 1970, 00:00:00 GMT represented by this `Date` object.
`int` | `hashCode()` Returns a hash code value for this object.
`void` | `setTime(long time)` Sets this `Date` object to represent a point in time that is `time` milliseconds after January 1, 1970 00:00:00 GMT.
`String` | `toString()` Converts this `Date` object to a `String` of the form:

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Date

    public Date()

  Allocates a `Date` object and initializes it so that it represents the time at which it was allocated, measured to the nearest millisecond.

  See Also:
    `System.currentTimeMillis()`

### Date

    public Date(long date)

  Allocates a `Date` object and initializes it to represent the specified number of milliseconds since the standard base time known as "the epoch", namely January 1, 1970, 00:00:00 GMT.

  Parameters:
    `date` - the milliseconds since January 1, 1970, 00:00:00 GMT.
  See Also:
    `System.currentTimeMillis()`

Method Detail

### clone

    public Object clone()

  Return a copy of this object.

  Returns:
    a clone of this instance.
  See Also:
    `Cloneable`

### getTime

    public long getTime()

  Returns the number of milliseconds since January 1, 1970, 00:00:00 GMT represented by this `Date` object.

  Returns:
    the number of milliseconds since January 1, 1970, 00:00:00 GMT represented by this date.

### setTime

    public void setTime(long time)

  Sets this `Date` object to represent a point in time that is `time` milliseconds after January 1, 1970 00:00:00 GMT.

  Parameters:
    `time` - the number of milliseconds.

### before

    public boolean before(Date when)

  Tests if this date is before the specified date.

  Parameters:
    `when` - a date.
  Returns:
    `true` if and only if the instant of time represented by this `Date` object is strictly earlier than the instant represented by `when`; `false` otherwise.

### after

    public boolean after(Date when)

  Tests if this date is after the specified date.

  Parameters:
    `when` - a date.
  Returns:
    `true` if and only if the instant represented by this `Date` object is strictly later than the instant represented by `when`; `false` otherwise.

### equals

    public boolean equals(Object obj)

  Compares two dates for equality. The result is `true` if and only if the argument is not `null` and is a `Date` object that represents the same point in time, to the millisecond, as this object.

  Thus, two `Date` objects are equal if and only if the `getTime` method returns the same `long` value for both.

  Overrides:
    `equals` in class `Object`
  Parameters:
    `obj` - the object to compare with.
  Returns:
    `true` if the objects are the same; `false` otherwise.
  See Also:
    `getTime()`

### compareTo

    public int compareTo(Date anotherDate)

  Compares two Dates for ordering.

  Parameters:
    `anotherDate` - the `Date` to be compared.
  Returns:
    the value `0` if the argument Date is equal to this Date; a value less than `0` if this Date is before the Date argument; and a value greater than `0` if this Date is after the Date argument.
  Since:
    1.2

### compareTo

    public int compareTo(Object o)

  Compares this Date to another Object. If the Object is a Date, this function behaves like `compareTo(Date)`. Otherwise, it throws a `ClassCastException` (as Dates are comparable only to other Dates).

  Specified by:
    `compareTo` in interface `Comparable`
  Parameters:
    `o` - the `Object` to be compared.
  Returns:
    the value `0` if the argument is a Date equal to this Date; a value less than `0` if the argument is a Date after this Date; and a value greater than `0` if the argument is a Date before this Date.
  Throws:
    `ClassCastException` - if the argument is not a `Date`.
  Since:
    1.2
  See Also:
    `Comparable`

### hashCode

    public int hashCode()

  Returns a hash code value for this object. The result is the exclusive OR of the two halves of the primitive `long` value returned by the `getTime()` method. That is, the hash code is the value of the expression:

  >      (int)(this.getTime()^(this.getTime() >>> 32))

  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### toString

    public String toString()

  Converts this `Date` object to a `String` of the form:

  >      dow mon dd hh:mm:ss zzz yyyy

  where:
  - `dow` is the day of the week (`Sun, Mon, Tue, Wed, Thu, Fri, Sat`).
  - `mon` is the month (`Jan, Feb, Mar, Apr, May, Jun, Jul, Aug, Sep, Oct, Nov, Dec`).
  - `dd` is the day of the month (`01` through `31`), as two decimal digits.
  - `hh` is the hour of the day (`00` through `23`), as two decimal digits.
  - `mm` is the minute within the hour (`00` through `59`), as two decimal digits.
  - `ss` is the second within the minute (`00` through `61`, as two decimal digits.
  - `zzz` is the time zone (and may reflect daylight saving time). Standard time zone abbreviations include those recognized by the method `parse`. If time zone information is not available, then `zzz` is empty - that is, it consists of no characters at all.
  - `yyyy` is the year, as four decimal digits.

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of this date.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD